#ifndef INC_REQ_newGA
#define INC_REQ_newGA
#include "newGA.hh"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sstream>
#include <algorithm>

skeleton newGA
{

	// Problem ---------------------------------------------------------------

	Problem::Problem ():_dimension(0),_limite_barrios(NULL),_tareasEsf(NULL),_tareasIndex(NULL),_empleados(NULL),_cantDias(0),_cantEmpleados(0)
	{
        //cout << "uf6";
    }

	ostream& operator<< (ostream& os, const Problem& pbm)
	{
		os << endl << endl << "Number of Columns " << pbm._cantColumnas;
		   << endl;

		os << "Number of Rows " << pbm._cantFilas << endl;

		os<<endl;
		return os;
	}



	istream& operator>> (istream& is, Problem& pbm)
	{
        
		char buffer[MAX_BUFFER];
		int i;

		//is.getline(buffer,MAX_BUFFER,'\n');
		//sscanf(buffer,"%d",&pbm._dimension);
        
        //CARGAR DATO CANT Tareas
        ifstream inFile;
        inFile.open("datos_cantidad_tareas");
        if (!inFile) 
        {
            cerr << "Unable to open file datafile.txt";
            exit(1);   // call system to stop
        }
        string x;
        getline(inFile,x);
        pbm._dimension = stoi(x);
        inFile.close();

		//Pido memoria para almacenar los limites de los barrios
		pbm._limite_barrios=new int *[pbm._dimension];
		for (int i=0;i<pbm._dimension;i++)
        {
			pbm._limite_barrios[i]=new int [10];
			for (int j=0;j<10;j++)
				pbm._limite_barrios[i][j]=-1;
		}
		
		//CARGAR DATO CANT EMPLEADOS
        inFile;
        inFile.open("datos_cantidad_empleados");
        if (!inFile) 
        {
            cerr << "Unable to open file datafile.txt";
            exit(1);   // call system to stop
        }
        //string x;
        getline(inFile,x);
        pbm._cantEmpleados = stoi(x);
        inFile.close();
        //INICIALIZAR DATOS TAREAS ESFUERZO
        pbm._tareasEsf=new int [pbm._dimension];
		for (int ii=0;ii<pbm._dimension;ii++)
        {
			pbm._tareasEsf[ii]=0;
		}
		
    
        //CARGAR DATOS TAREAS ESFUERZO
    
        inFile.open("datos_tareas");
        if (!inFile) 
        {
            cerr << "Unable to open file datafile.txt";
            exit(1);   // call system to stop
        }
        string line2;
        getline(inFile,line2);
        pbm._cantDias = stoi(line2);
        getline(inFile, line2);
        getline(inFile, line2);
       
        int n = line2.length(); 
        char char_array[n+1];  
        int len=1;
        int t=0;
        int z=0;
        for(int i=0; i<=line2.length(); i++) 
        {
            if(line2[i] == ' '|| i==line2.length()) 
            {
                string rr = line2.substr(z,len);
                pbm._tareasEsf[t] = stoi(rr);
                //cout << rr << " ";
                t=t+1;
                z=i+1;
                len=1;
                //s.erase(i,1);
            }
            else len=len+1;
        }
        inFile.close();
        
        
        pbm._tareasIndex = new int[pbm._dimension];
        for (int i = 0 ; i != pbm._dimension ; i++) 
        {
            pbm._tareasIndex[i] = i;
        }
        sort(pbm._tareasIndex, pbm._tareasIndex + pbm._dimension,[&](const int& a, const int& b) { return (pbm._tareasEsf[a] < pbm._tareasEsf[b]); });
        /*
        for (int i = 0 ; i != pbm._dimension ; i++) 
        {
            cout << pbm._tareasIndex[i] << " ";
        }
        exit(0);
        */
        
        //INICIALIZAR EMPLEADOS
        pbm._empleados=new Empleado [pbm._cantEmpleados];
		for (int zz=0;zz<pbm._cantEmpleados;zz++)
        {

            pbm._empleados[zz]._sueldo = 0;
            pbm._empleados[zz]._habilidad=0;
            pbm._empleados[zz]._horas=0;
        }
		
       //CARGAS DATOS EMPLEADOS
       
       string line23;
        inFile.open("datos_empleados");
        getline(inFile, line23);
        getline(inFile, line23);
       int no = line23.length(); 
        char_array[n+1];  
        len=1;
        t=0;
        z=0;
        for(int i=0; i<=line23.length(); i++) 
        {
            if(line23[i] == ' ' || i==line23.length()) 
            {
                string rrr = line23.substr(z,len);
                pbm._empleados[t]._horas = stoi(rrr);
                //cout << rr << " ";
                t=t+1;
                z=i+1;
                len=1;
                //s.erase(i,1);
            }
            else len=len+1;
        }
        cout << pbm._empleados[0]._horas <<" " << pbm._empleados[1]._horas <<" " << pbm._empleados[2]._horas <<" " << pbm._empleados[3]._horas << " " << pbm._empleados[4]._horas << " " << endl;
       
        getline(inFile, line23);
       no = line23.length(); 
        char_array[n+1];  
        len=1;
        t=0;
        z=0;
       // cout << line23;
        for(int i=0; i<=line23.length(); i++) 
        {
            if(line23[i] == ' ' || i==line23.length()) 
            {
                string rrr = line23.substr(z,len);
                pbm._empleados[t]._habilidad = stof(rrr);
                //cout << rrr << " ";
                t=t+1;
                z=i+1;
                len=1;
                //s.erase(i,1);
            }
            else len=len+1;
        }
        cout << pbm._empleados[0]._habilidad <<" " << pbm._empleados[1]._habilidad <<" " << pbm._empleados[2]._habilidad <<" " << pbm._empleados[3]._habilidad << " " << pbm._empleados[4]._habilidad << " " << endl;
        
        getline(inFile, line23);
       no = line23.length(); 
        char_array[n+1];  
        len=1;
        t=0;
        z=0;
        for(int i=0; i<=line23.length(); i++) 
        {
            if(line23[i] == ' ' || i==line23.length()) 
            {
                string rrr = line23.substr(z,len);
                pbm._empleados[t]._sueldo = stoi(rrr);
                //cout << rr << " ";
                t=t+1;
                z=i+1;
                len=1;
                //s.erase(i,1);
            }
            else len=len+1;
        }
       cout << pbm._empleados[0]._sueldo <<" " << pbm._empleados[1]._sueldo <<" " << pbm._empleados[2]._sueldo <<" " << pbm._empleados[3]._sueldo << " " << pbm._empleados[4]._sueldo << " " << endl;
       //assert(false);
       inFile.close();
       
       /*
		//Cargo el archivo con los limites de los barrios
	    FILE* stream = fopen("limite_barrios.csv", "r");

	    char line[1024];
	    while (fgets(line, 1024, stream))
	    {
	        char* tmp = strdup(line);
	        const char * barrio = pbm.getfield(tmp,1);
	        int barrio_int=atoi(barrio);
			tmp = strdup(line);	
	        const char * limite= pbm.getfield(tmp,2);
	        int i=0;
	        while (limite!=NULL)
            {
	        	pbm._limite_barrios[barrio_int-1][i]=atoi(limite)-1;
	        	i++;
	        	tmp = strdup(line);
	        	limite=pbm.getfield(tmp,i+2);
	        }
	        free(tmp);
	    }
	    */
		cout<<pbm;
		return is;
	}

	//Funcion para leer el archivo CSV
	const char* Problem::getfield(char* line, int num)
	{
	    const char* tok;
	    for (tok = strtok(line, ",");
	            tok && *tok;
	            tok = strtok(NULL, ",\n"))
	    {
	        if (!--num)
	            return tok;
	    }
	    return NULL;
	}

	int ** Problem::limite_barrios() const{
		return _limite_barrios;
	}


	bool Problem::operator== (const Problem& pbm) const
	{
		if (_dimension!=pbm.dimension()) return false;
		return true;
	}

	bool Problem::operator!= (const Problem& pbm) const
	{
		return !(*this == pbm);
	}

	Direction Problem::direction() const
	{
		//return maximize;
		return minimize;
	}

	int Problem::cantColumnas() const
	{
		return _cantColumnas;
	}
	int Problem::cantFilas() const
	{
		return _cantFilas;
	}
	
	int ** Problem::datosFilas() const
	{
		return _datosFilas;
	}
	
	int ** Problem::datosColumnas() const
	{
		return _datosColumnas;
	}

	int * Problem::cantGruposColumna() const
	{
		return _cantGruposColumna();
	}

	int * Problem::cantGruposFila() const
	{
		return _cantGruposFila();
	}

	Problem::~Problem()
	{
		//Libero la memoria pedida para almacenar los limites de los barrios
		delete[] _datosColumnas;
		delete[] _datosFilas;
	}

	// Solution --------------------------------------------------------------

	Solution::Solution (const Problem& pbm):_pbm(pbm),_var(pbm.dimension())
	{}

	const Problem& Solution::pbm() const
	{
		return _pbm;
	}

	Solution::Solution(const Solution& sol):_pbm(sol.pbm())
	{
		*this=sol;
	}

	istream& operator>> (istream& is, Solution& sol)
	{
		for (int i=0;i<sol.pbm().dimension();i++)
			is >> sol._var[i];
		return is;
	}

	ostream& operator<< (ostream& os, const Solution& sol)
	{
        
		//for (int i=0;i<sol.pbm().dimension();i++)
		//	os << " " << sol._var[i];
        stringstream ss;
        
        ofstream outfile("solution");
        
        os << endl;
        
        for (int j = 0; j < sol.pbm().cantEmpleados(); j++)
        {
            bool found1 = false;
            for (int i = 0; i < sol.pbm().dimension(); i++)
            {
                if (sol._var[i] == j)
                {
                    if (!found1)
                    {
                        ss << "e" << j + 1;
                        found1 = true;
                    }
                    
                    ss << " t" << sol.pbm().tareasIndex()[i] + 1;
                }
            }
            
            if (found1)
            {
                ss << endl;
            }
        }
        
        outfile << ss.str();
        outfile.close();
        
        os << ss.str();
        
		return os;
	}

	NetStream& operator << (NetStream& ns, const Solution& sol)
	{
		for (int i=0;i<sol._var.size();i++)
			ns << sol._var[i];
		return ns;
	}

	NetStream& operator >> (NetStream& ns, Solution& sol)
	{
		for (int i=0;i<sol._var.size();i++)
			ns >> sol._var[i];
		return ns;
	}

 	Solution& Solution::operator= (const Solution &sol)
	{
		_var=sol._var;
		return *this;
	}

	bool Solution::operator== (const Solution& sol) const
	{
		if (sol.pbm() != _pbm) return false;
		for(int i = 0; i < _var.size(); i++)
			if(_var[i] != sol._var[i]) return false;
		return true;
	}

	bool Solution::operator!= (const Solution& sol) const
	{
		return !(*this == sol);
	}

	void Solution::initialize()
	{  
		for (int x = 0; x < _pbm.cantColumnas(); x++)
		{
			for (int y = 0; y < _pbm.cantFilas(); y++)
			{
				_var[x][y] = 0;
			}
		}

		for (int i=0;i<_pbm.cantColumnas();i++)
        {
			int _firstPossible = 0;
			int** _grupos = _pbm.datosColumnas();
			int* _cantGruposEnColumna = _pbm.cantGruposColumna();

			for(int j=0; j < _cantGruposEnColumna[i]; j++)
			{
				int _lastPossible = _pbm.cantFilas() - _grupos[i][j];
				for (int k=j+1; k < _cantGruposEnColumna[i]; k++)
				{
					_lastPossible -= _grupos[i][k] + 1;
				}

				int _startPosition = rand_int(_firstPossible, _lastPossible);
				int _endPosition = _startPosition + _grupos[i][j] - 1;
				for(int c = _startPosition; c < _endPosition; c++)
				{
					_var[j][c] = 1;
				}

				_firstPossible = _endPosition + 1;
			}
        }
	}

	double Solution::fitness ()
	{

        double fitness = 0.0;
        double* horasTrabajados = new double[_pbm.cantEmpleados()];
        for (int q=0; q < _pbm.cantEmpleados(); q++)
        {
            horasTrabajados[q] = 0;
        }
        
		for (int i=0;i< _pbm.dimension();i++) 
        {
			Empleado tipo = _pbm.empleados()[_var[i]];
            double horasReq = ((double)_pbm.tareasEsf()[_pbm.tareasIndex()[i]]/(double)(0.5+tipo._habilidad));
            horasTrabajados[_var[i]] += horasReq;

        }
        
        
        for (int j = 0; j < _pbm.cantEmpleados(); j++)
        {   
            double diasTrabajadosTemp = (double)horasTrabajados[j] / (double)_pbm.empleados()[j]._horas;
            fitness += (double)diasTrabajadosTemp * (double)_pbm.empleados()[j]._sueldo;
            if (isnan(fitness))
            exit(0);
            if (diasTrabajadosTemp > _pbm.cantDias())
            {
                fitness += 100000;
            }
        }
        
		return fitness;

	}

	char *Solution::to_String() const
	{
		return (char *)_var.get_first();
	}

	void Solution::to_Solution(char *_string_)
	{
		int *ptr=(int *)_string_;
		for (int i=0;i<_pbm.dimension();i++)
		{
			_var[i]=*ptr;
			ptr++;
		}
	}

	unsigned int Solution::size() const
	{
		return (_pbm.dimension() * sizeof(int));
	}


	int& Solution::var(const int index)
	{
		return _var[index];
	}


	Rarray<int>& Solution::array_var()
	{
		return _var;
	}

	Solution::~Solution()
	{}

	// UserStatistics -------------------------------------------------------

	UserStatistics::UserStatistics ()
	{}

	ostream& operator<< (ostream& os, const UserStatistics& userstat)
	{
		os << "\n---------------------------------------------------------------" << endl;
		os << "                   STATISTICS OF TRIALS                   	 " << endl;
		os << "------------------------------------------------------------------" << endl;

		for (int i=0;i< userstat.result_trials.size();i++)
		{
			os << endl
			   << userstat.result_trials[i].trial
			   << "\t" << userstat.result_trials[i].best_cost_trial
			   << "\t\t" << userstat.result_trials[i].worst_cost_trial
			   << "\t\t\t" << userstat.result_trials[i].nb_evaluation_best_found_trial
			   << "\t\t\t" << userstat.result_trials[i].nb_iteration_best_found_trial
			   << "\t\t\t" << userstat.result_trials[i].time_best_found_trial
			   << "\t\t" << userstat.result_trials[i].time_spent_trial;
		}
		os << endl << "------------------------------------------------------------------" << endl;
		return os;
	}

	UserStatistics& UserStatistics::operator= (const UserStatistics& userstats)
	{
		result_trials=userstats.result_trials;
		return (*this);
	}

	void UserStatistics::update(const Solver& solver)
	{
		if( (solver.pid()!=0) || (solver.end_trial()!=true)
		  || ((solver.current_iteration()!=solver.setup().nb_evolution_steps())
		       && !terminateQ(solver.pbm(),solver,solver.setup())))
			return;

		struct user_stat *new_stat;

		if ((new_stat=(struct user_stat *)malloc(sizeof(struct user_stat)))==NULL)
			show_message(7);
		new_stat->trial         		 		 = solver.current_trial();
		new_stat->nb_evaluation_best_found_trial = solver.evaluations_best_found_in_trial();
		new_stat->nb_iteration_best_found_trial  = solver.iteration_best_found_in_trial();
		new_stat->worst_cost_trial     		 	 = solver.worst_cost_trial();
		new_stat->best_cost_trial     		 	 = solver.best_cost_trial();
		new_stat->time_best_found_trial		 	 = solver.time_best_found_trial();
		new_stat->time_spent_trial 		 		 = solver.time_spent_trial();

		result_trials.append(*new_stat);
	}

	void UserStatistics::clear()
	{
		result_trials.remove();
	}

	UserStatistics::~UserStatistics()
	{
		result_trials.remove();
	}

// Intra_operator  --------------------------------------------------------------

	Intra_Operator::Intra_Operator(const unsigned int _number_op):_number_operator(_number_op),probability(NULL)
	{}

	unsigned int Intra_Operator::number_operator() const
	{
		return _number_operator;
	}

	Intra_Operator *Intra_Operator::create(const unsigned int _number_op)
	{
		switch (_number_op)
		{
			case 0: return new Crossover;break;
			case 1: return new Mutation();break;
		}
	}

	ostream& operator<< (ostream& os, const Intra_Operator& intra)
	{
		switch (intra.number_operator())
		{
			case 0: os << (Crossover&)intra;break;
			case 1: os << (Mutation&)intra;break;
		}
		return os;
	}

	Intra_Operator::~Intra_Operator()
	{}

//  Crossover:Intra_operator -------------------------------------------------------------

	Crossover::Crossover():Intra_Operator(0)
	{
		probability = new float[1];
	}

	void Crossover::cross(Solution& sol1,Solution& sol2) const // dadas dos soluciones de la poblacion, las cruza
	{
		//Usamos cruzamiento de dos puntos (2PX)
		int i=0;
		Rarray<int> aux(sol1.pbm().dimension());
		aux=sol2.array_var();

        /*
        if (current_time_spent() < 1000000)
        {
            int limit=rand_int((0,sol1.pbm().dimension()-1));

            for (i=0;i<limit;i++)
                sol2.var(i)=sol1.var(i);
            for (i=0;i<limit;i++)
                sol1.var(i)=aux[i];
        }
        if (current_time_spent() >= 1000000)
        {*/
            int limit=rand_int((sol1.pbm().dimension()/2)+1,sol1.pbm().dimension()-1);
            int limit2=rand_int(0,limit-1);

            for (i=0;i<limit2;i++)
                sol2.var(i)=sol1.var(i);
            for (i=0;i<limit2;i++)
                sol1.var(i)=aux[i];
            for (i=limit;i<sol1.pbm().dimension();i++)
                sol2.var(i)=sol1.var(i);
            for (i=limit;i<sol1.pbm().dimension();i++)
                sol1.var(i)=aux[i];
        //}
	}

	void Crossover::execute(Rarray<Solution*>& sols) const
	{
		for (int i=0;i+1<sols.size();i=i+2)
		 	if (rand01()<=probability[0]) cross(*sols[i],*sols[i+1]);
	}

	ostream& operator<< (ostream& os, const Crossover&  cross)
	{
		 os << "Crossover." << " Probability: "
                    << cross.probability[0]
		    << endl;
		 return os;
	}

	void Crossover::RefreshState(const StateCenter& _sc) const
	{
		_sc.set_contents_state_variable("_crossover_probability",(char *)probability,1,sizeof(float));
	}

	void Crossover::UpdateFromState(const StateCenter& _sc)
	{
		 unsigned long nbytes,length;
		 _sc.get_contents_state_variable("_crossover_probability",(char *)probability,nbytes,length);
	}

	void Crossover::setup(char line[MAX_BUFFER])
	{
		int op;
		sscanf(line," %d %f ",&op,&probability[0]);
		assert(probability[0]>=0);
	}

	Crossover::~Crossover()
	{
		delete [] probability;
	}

	//  Mutation: Sub_operator -------------------------------------------------------------

	Mutation::Mutation():Intra_Operator(1)
	{
		probability = new float[2];
	}

	void Mutation::mutate(Solution& sol) const
	{
		for (int i=0;i<sol.pbm().dimension();i++)
		{
			if (rand01()<=probability[1])
			{
				//La mutacion modifica un gen aleatoriamente con probabilidad uniforme en {0,3}
                int temp = rand_int(0,sol.pbm().cantEmpleados() - 1);
				sol.var(i)= temp;
                //sol.var(i)=rand_int(0,3);
			}
		}
	}

	void Mutation::execute(Rarray<Solution*>& sols) const
	{
		for (int i=0;i<sols.size();i++)
			if(rand01() <= probability[0])	mutate(*sols[i]);
	}

	ostream& operator<< (ostream& os, const Mutation&  mutation)
	{
		os << "Mutation." << " Probability: " << mutation.probability[0]
		   << " Probability1: " << mutation.probability[1]
		   << endl;
		return os;
	}

	void Mutation::setup(char line[MAX_BUFFER])
	{
		int op;
		sscanf(line," %d %f %f ",&op,&probability[0],&probability[1]);
		assert(probability[0]>=0);
		assert(probability[1]>=0);
	}

	void Mutation::RefreshState(const StateCenter& _sc) const
	{
		_sc.set_contents_state_variable("_mutation_probability",(char *)probability,2,sizeof(probability));
	}

	void Mutation::UpdateFromState(const StateCenter& _sc)
	{
		unsigned long nbytes,length;
		_sc.get_contents_state_variable("_mutation_probability",(char *)probability,nbytes,length);
	}

	Mutation::~Mutation()
	{
		delete [] probability;
	}

// StopCondition_1 -------------------------------------------------------------------------------------

	StopCondition_1::StopCondition_1():StopCondition()
	{}

	bool StopCondition_1::EvaluateCondition(const Problem& pbm,const Solver& solver,const SetUpParams& setup)
	{    
       bool fin=(int) (solver.current_time_spent() - solver.time_best_found_trial()) > 20000000;
		//Condicion de parada. Si el fitness es 0 terminamos la ejecucion.
		//bool fin=(int)solver.best_cost_trial() == 0;
        //cout << pbm.cantEmpleados();
        /*if (fin){
			//Escribo el resultado en el archivo de salida
			FILE * pFile;
			pFile = fopen ("asignacion_colores.csv","w");
			for (int i=0;i<pbm.dimension();i++){
				fprintf (pFile, "%d,%d\n",i+1,solver.best_solution_trial().var(i));
			}
			fclose (pFile);
		}*/
		//return (fin);
        return fin;
        
    }

	StopCondition_1::~StopCondition_1()
	{}

	//------------------------------------------------------------------------
	// Specific methods ------------------------------------------------------
	//------------------------------------------------------------------------

	bool terminateQ (const Problem& pbm, const Solver& solver,
			 const SetUpParams& setup)
	{
		StopCondition_1 stop;
		return stop.EvaluateCondition(pbm,solver,setup);
	}
}
#endif

